Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 1928)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 1929)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Bugfix in check for use_upstream_for_tke
 !
 ! Former revisions:
@@ -894,5 +894,5 @@
     IF ( use_sgs_for_particles  .AND.  .NOT. cloud_droplets  .AND.               &
          .NOT. use_upstream_for_tke  .AND.                                       &
-         ( scalar_advec /= 'ws-scheme'  .OR.  scalar_advec /= 'ws-scheme-mono' ) &
+         ( scalar_advec /= 'ws-scheme'  .AND.  scalar_advec /= 'ws-scheme-mono' )&
        )  THEN
        use_upstream_for_tke = .TRUE.
Index: /palm/trunk/SOURCE/lpm.f90
===================================================================
--- /palm/trunk/SOURCE/lpm.f90	(revision 1928)
+++ /palm/trunk/SOURCE/lpm.f90	(revision 1929)
@@ -19,5 +19,6 @@
 ! Current revisions:
 ! ------------------
-!
+! Call wall boundary conditions only if particles are in the vertical range of 
+! topography.
 ! 
 ! Former revisions:
@@ -111,5 +112,5 @@
 
     USE indices,                                                               &
-        ONLY: nxl, nxr, nys, nyn, nzb, nzt
+        ONLY: nxl, nxr, nys, nyn, nzb, nzb_max, nzt, nzb_w_inner
 
     USE kinds
@@ -300,6 +301,8 @@
                 CALL lpm_advec(i,j,k)
 !
-!--             Particle reflection from walls
-                IF ( topography /= 'flat' )  THEN
+!--             Particle reflection from walls. Only applied if the particles 
+!--             are in the vertical range of the topography. (Here, some
+!--             optimization is still possible.)
+                IF ( topography /= 'flat' .AND. k < nzb_max + 2 )  THEN
                    CALL lpm_boundary_conds( 'walls' )
                 ENDIF
@@ -334,5 +337,4 @@
        steps = steps + 1
        dt_3d_reached_l = ALL(grid_particles(:,:,:)%time_loop_done)
-
 !
 !--    Find out, if all particles on every PE have completed the LES timestep
@@ -359,5 +361,4 @@
 !--    Horizontal boundary conditions including exchange between subdmains
        CALL lpm_exchange_horiz
-
 !
 !--    Pack particles (eliminate those marked for deletion),
